////////////////////////////////////////////////////////////////////////////////
//                            keyboard_pc.c                                   //
// this library is wrriten to use pc keyboard.                                //
// for use you must first defined two line for data and clock port for        //
// keyboard.                                                                  //
//                                                                            //
// therfore we have:                                                          //
//                                                                            //
//in this library defined pc_data pin_c7 and pc_clock pin_c6                  //
// ----------user function------------------                                  //
//    ===============================                                         //
// keyboard_init();                                                           //
//                 must called before any of function that work with keyboard.//
//          return 1:if ok                                                    //
//          return  0:if not ok                                               //
//    ===============================                                         //
// keyboard_getc();                                                           //
//                 micro wait to get character from keyboard.                 //
//    ===============================                                         //
// char keyboard_gets(int length,char  *array,int8 lcd_x,int8 lcd_y,          //
//                    short inverse);                                         //
//                 length:tedad characterhaye daryafti                        //
//                 array:arayeiee ke characterha dar an gharar migirand       //
//         dar soorate zadan enter adad 1 va zadane kelide esc adad 0         //
//    ===============================                                         //
// ----------internal function--------------                                  //
// get_key();                                                                 //
// keyboard_init_to_recive(void);                                             //
// keyboard_init_to_transfer(void);                                           //
// send_command(char  data);                                                  //
// set_or_reset_led(char leds_state);                                         //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////
#ifndef      _KEYBOARD_PC_H_
#define      _KEYBOARD_PC_H_

#include "delay.h"
//-----------------------------------------------------------------------------
#ifndef                       keyboard_port
#define                       keyboard_port                       0
#endif
#ifndef                       keyboard_data_pin                    
#define                       keyboard_data_pin                   0            
#endif
#ifndef                       keyboard_clock_pin             
#define                      keyboard_clock_pin                   1
#endif
//-----------------------------------------------------------------------------
#define                       ESC                         0x00
#define                       F1                          0x01
#define                       F2                          0x02
#define                       F3                          0x03
#define                       F4                          0x04
#define                       F5                          0x05
#define                       F6                          0x06
#define                       F7                          0x07
#define                       F8                          0x08
#define                       F9                          0x09
#define                       F10                         0x0a
#define                       F11                         0x0b
#define                       F12                         0x0c
#define                       PRINTSCREEN                 0x0d
#define                       SCROLLOCK                   0x0e
#define                       PAUSEBREAK                  0x0f
#define                       BACKSPACE                   0x10
#define                       INSERT                      0x11
#define                       HOME                        0x12
#define                       PAGE_UP                     0x13
#define                       NUMLOCK                     0x14
#define                       TAB                         0x15
#define                       DELETE                      0x16
#define                       END                         0x17
#define                       PAGE_DOWN                   0x18
#define                       CAPSLOCK                    0x19
#define                       ENTER                       0x1a
#define                       SHIFT                       0x1b
#define                       KEY_UP                      0x1c
#define                       CTRL                        0x1d
#define                       ALT                         0x1e
#define                       KEY_LEFT                    0x1f
#define                       KEY_DOWN                    0x7f
#define                       KEY_RIGHT                   0x80
#define                       SPACE                       ' '

#define                       SCROLLOCK_POSITION          0
#define                       NUMLOCK_POSITION            1
#define                       CAPSLOCK_POSITION           2

#define                       SCROLLOCK_LED_ON            1<<SCROLLOCK_POSITION
#define                       NUMLOCK_LED_ON              1<<NUMLOCK_POSITION
#define                       CAPSLOCK_LED_ON             1<<CAPSLOCK_POSITION
//-----------------------------------------------------------------------------
const char char_without_shift[]={  0x00,F9,0x02,F5,F3,F1,F2,F12,0x08,F10,F8,F6,F4,TAB,'`',0x0f,                           /*0*/
                                   0x00,ALT,SHIFT,0x03,CTRL,'q','1',0x07,0x08,0x09,'z','s','a','w','2',0x0f,              /*1*/
                                   0x00,'c','x','d','e','4','3',0x07,0x08,SPACE,'v','f','t','r','5',0x0f,                 /*2*/
                                   0x00,'n','b','h','g','y','6',0x07,0x08,0x09,'m','j','u','7','8',0x0f,                  /*3*/
                                   0x00,',','k','i','o','0','9',0x07,0x08,'.','/','l',';','p','-',0x0f,                   /*4*/
                                   0x00,0x01,'\'',0x03,'[','=',0x06,0x07,CAPSLOCK,SHIFT,ENTER,']',0x0c,'\\',0x0e,0x0f,    /*5*/
                                   0x00,0x01,0x02,0x03,0x04,0x05,BACKSPACE,0x07,0x08,'1',0x0a,'4','7',0x0d,0x0e,0x0f,     /*6*/
                                   '0','.','2','5','6','8',ESC,NUMLOCK,F11,'+','3','-','*','9',SCROLLOCK,0x0f,            /*7*/
                                   0x00,0x01,0x02,F7,0x04,0x05,0x06,0x07,0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f         /*8*/};
                                 //----------------
const char  char_with_shift[]={    0x00,F9,0x02,F5,F3,F1,F2,F12,0x08,F10,F8,F6,F4,TAB,'~',0x0f,                           /*0*/
        						   0x00,ALT,SHIFT,0x03,CTRL,'q','!',0x07,0x08,0x09,'z','s','a','w','@',0x0f,              /*1*/
                                   0x00,'c','x','d','e','$','#',0x07,0x08,SPACE,'v','f','t','r','%',0x0f,                 /*2*/
                                   0x00,'n','b','h','g','y','^',0x07,0x08,0x09,'m','j','u','&','*',0x0f,                  /*3*/
                                   0x00,'<','k','i','o',')','(',0x07,0x08,'>','?','l',':','p','_',0x0f,                   /*4*/
                                   0x00,0x01,'"',0x03,'{','+',0x06,0x07,CAPSLOCK,SHIFT,ENTER,'}',0x0c,'|',0x0e,0x0f,      /*5*/
                                   0x00,0x01,0x02,0x03,0x04,0x05,BACKSPACE,0x07,0x08,'1',0x0a,'4','7',0x0d,0x0e,0x0f,     /*6*/
                                   '0','.','2','5','6','8',ESC,NUMLOCK,F11,'+','3','-','*','9',SCROLLOCK,0x0f,            /*7*/
                                   0x00,0x01,0x02,F7,0x04,0x05,0x06,0x07,0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f         /*8*/};
//-----------------------------------------------------------------------------
char      capslock_state=0;           //neshandahande on or off capslock
char      numlock_state=1;
char      scrollock_state=0;
char      shift_state=0;
//-----------------------------------------------------------------------------
//-------------------------------------user function----------------
char              keyboard_init(void);                             //init avaliye
void              keyboard_init_to_recive(void);                   //init jahate daryafte data
void              keyboard_init_to_transfer(void);                 //init jahat  ersal command
char              send_command(char  data);                        //ersal yek farman be keyboard
char              set_or_reset_led(void);                  //roshan va khamoosh kardan led haye keyboard
char              keyboard_getkey(void);                           //return key from keyboard
char              keyboard_getchar(void);                          //daryafte yek character az keyboard
char              keyboard_getstring(uint16_t char_count,char  *array,uint16_t  lcd_x,uint16_t lcd_y,char inverse);
                                                              //daryafte yek reshte az keyboard
//-------------------------------------internal function------------
char               get_key(void);
//-----------------------------------------------------------------------------
char       keyboard_init(void)
{
	keyboard_init_to_recive();
	set_or_reset_led();
   return 1;
}
//-----------------------------------------------------------------------------
void         keyboard_init_to_recive(void)
{
   GPIO_SetDir(keyboard_port , (1<<keyboard_data_pin) | (1<<keyboard_clock_pin) ,0);
}
//------------------------------------------------------------------------------
void         keyboard_init_to_transfer(void)
{
   GPIO_SetDir(keyboard_port , (1<<keyboard_data_pin) | (1<<keyboard_clock_pin) ,1);
   GPIO_SetValue(keyboard_port , (1<<keyboard_data_pin) | (1<<keyboard_clock_pin));
   delay_us(100);
   GPIO_ClearValue(keyboard_port ,(1<<keyboard_clock_pin));
   delay_ms(1);
   GPIO_ClearValue(keyboard_port ,(1<<keyboard_data_pin));
   delay_us(300);
   GPIO_SetDir(keyboard_port , 1<<keyboard_clock_pin ,0);
}
//--------------------------------------------------------------------------------
char         set_or_reset_led(void)
{
   uint8_t response,i,parity_bit_count=0;
   char      leds_state=0;
   if(numlock_state)
	   leds_state|=NUMLOCK_LED_ON;
   if(capslock_state)
   	   leds_state|=CAPSLOCK_LED_ON;
   if(scrollock_state)
   	   leds_state|=SCROLLOCK_LED_ON;
   response=send_command(0xed) ;
   response=get_key();
   if(response!=0xfa)
            return 0;
   response=send_command(leds_state);
   if(!response)
         return 0;
   return 1;
}
//---------------------------------------------------------------------------------
char         send_command(char  data)
{
	unsigned char i,parity_bit_count=0,response;
   response=1;
   for(i=0;i<8;i++)
   {
      if(data & (1<<i))
         parity_bit_count++;   
   }
   keyboard_init_to_transfer();
   while(GPIO_ReadValue(keyboard_port) & (1<<keyboard_clock_pin));
   while(!(GPIO_ReadValue(keyboard_port) & (1<<keyboard_clock_pin)));
   for(i=0;i<8;i++)
   {
      if(data & (1<<i))
         GPIO_SetValue(keyboard_port , 1<<keyboard_data_pin);
      else
         GPIO_ClearValue(keyboard_port , 1<<keyboard_data_pin);
      while(GPIO_ReadValue(keyboard_port) & (1<<keyboard_clock_pin));
      while(!(GPIO_ReadValue(keyboard_port) & (1<<keyboard_clock_pin)));
   }
   if(parity_bit_count%2)
      GPIO_ClearValue(keyboard_port , 1<<keyboard_data_pin);
   else
      GPIO_SetValue(keyboard_port , 1<<keyboard_data_pin);
   while(GPIO_ReadValue(keyboard_port) & (1<<keyboard_clock_pin));
   GPIO_SetDir(keyboard_port , 1<<keyboard_data_pin ,0);
   while(!(GPIO_ReadValue(keyboard_port) & (1<<keyboard_clock_pin)));
   while(GPIO_ReadValue(keyboard_port) & (1<<keyboard_clock_pin));
   if(GPIO_ReadValue(keyboard_port) & (1<<keyboard_data_pin))
	   response= 0;
   while(!(GPIO_ReadValue(keyboard_port) & (1<<keyboard_clock_pin)));
   return response;
}
//----------------------------------------------------------------------------------
char       keyboard_getkey(void)  //return key from keyboard
{
      char         esi;
      while(1)
      {
        while(esi=get_key(),(esi!=0xf0)&&(esi!=0xe0) &&(esi!=0x12));
        if(esi==0xf0)
            return char_without_shift[get_key()];
        if(esi==0xe0)
        {
            while(esi=get_key(),esi!=0xf0 && esi!=0x12);
            if(esi=0x12)
            	goto shift_key;
            esi=get_key();
            switch(esi)
            {
               case   0x11:return(ALT);break;
               case   0x14:return(CTRL);break;
               case   0x4a:return('/');break;
               case   0x5a:return(ENTER);break;    
               case   0x70:return(INSERT);break;
               case   0x6c:return(HOME);break;
               case   0x7d:return(PAGE_UP);break;
               case   0x71:return(DELETE);break;
               case   0x69:return(END);break;
               case   0x7a:return(PAGE_DOWN);break;
               case   0x75:return(KEY_UP);break;
               case   0x6b:return(KEY_LEFT);break;
               case   0x72:return(KEY_DOWN);break;
               case   0x74:return(KEY_RIGHT);break;
            }
        }
        if(esi==0x12)
        {
shift_key:
        	while(esi=get_key(),(esi!=0xf0));
        	esi=get_key();
        	if((esi==0x12) || (esi==0xe0))
        		continue;
        	shift_state=1;
        	return char_with_shift[esi];
        }
      }
}
//-----------------------------------------------------------------------------
char         keyboard_getchar(void)
{
	char esi;
	for( ; ; )
	{
		esi=keyboard_getkey();
		if(esi==CAPSLOCK)
		            {
		                     if(capslock_state)
		                        capslock_state=0;
		                     else
		                        capslock_state=1;
		                     set_or_reset_led();
		                     continue;
		            }
		            if(esi==NUMLOCK)
		            {
		                     if(numlock_state)
		                        numlock_state=0;
		                     else
		                    	 numlock_state=1;
		                     set_or_reset_led();
		                     continue;
		            }
		            if(esi==SCROLLOCK)
		            {
		                     if(scrollock_state)
		                        scrollock_state=0;
		                     else
		                        scrollock_state=1;
		                     set_or_reset_led();
		                     continue;
		            }
		            if(esi>=' ' && esi<='~')
		            {
						if(capslock_state)
						{
							if(shift_state)
							{
								shift_state=0;
								return(tolower(esi));
							}
							else
								return(toupper(esi));
						}
						else
						{
							if(shift_state)
							{
								shift_state=0;
								return(toupper(esi));
							}
							else
							    return(tolower(esi));
						}
		            }
	}
}
//-----------------------------------------------------------------------------
char       get_key(void)
{
   char      ebi=0,i;
   while(GPIO_ReadValue(keyboard_port) & (1<<keyboard_clock_pin));
   while(!(GPIO_ReadValue(keyboard_port) & (1<<keyboard_clock_pin)));
   for(i=0;i<8;i++)
   {
      while(GPIO_ReadValue(keyboard_port) & (1<<keyboard_clock_pin));
      if(GPIO_ReadValue(keyboard_port) & (1<<keyboard_data_pin))
    	  ebi |=(1<<i);
      while(!(GPIO_ReadValue(keyboard_port) & (1<<keyboard_clock_pin)));
   }
   while(GPIO_ReadValue(keyboard_port) & (1<<keyboard_clock_pin));
   while(!(GPIO_ReadValue(keyboard_port) & (1<<keyboard_clock_pin)));
   while(GPIO_ReadValue(keyboard_port) & (1<<keyboard_clock_pin));
   while(!(GPIO_ReadValue(keyboard_port) & (1<<keyboard_clock_pin)));
   return	ebi;
}
//-----------------------------------------------------------------------------
char keyboard_gets(uint8_t length,char  *array,uint16_t lcd_x,uint16_t lcd_y,uint8_t inverse)
{
      char  character;
      char  string[100];
      char  display_char[3];
      int   glcd_x,glcd_y;
      int   i;
      int   j;
      glcd_x=lcd_x;
      glcd_y=lcd_y;
      for(i=0;i<length; )
      {
         character=keyboard_getchar();
         if(character==ENTER)
         {
            for(j=0;j<i;j++)
               *(array++)=string[j];
            return(1);
         }
         if(character==ESC)
            return(0);
         if(character==BACKSPACE)
         {
backbackspace:
         #ifdef    lcd      //------dar sorate estefade az lcd characteri
               if(i>0)
               {
                      lcd_x--;
                  lcd_gotoxy(lcd_x,lcd_y);
                  lcd_putc(' ');
                  lcd_gotoxy(lcd_x,lcd_y);
                  i--
               }
               continue;
          #endif
          #ifdef  glcd      //-------dar sorate estefade az glcd
               if(i>0)
               {
                  glcd_x-=6;
                  glcd_rect(glcd_x,glcd_y,glcd_x+5,glcd_y+7,1,inverse);
                  i--;
               }
               continue;
          #endif
          #ifdef   tft_lcd  //-------dar sorate estefade az tft_lcd
               if(i>0)
               {
                  glcd_x-=9;
                   lcd_rectangle(glcd_x,glcd_y,glcd_x+8,glcd_y+16,white,inverse);
                   i--;
               }
          #endif
         //------------------------------------------------------------
         }
         if(character>=0x20&&character<=0x7e)
         {
            string[i]=character;
            sprintf(display_char,"%c",character);
            #ifdef          lcd
               lcd_gotoxy(lcd_x,lcd_y);
               lcd_putc(character);
               lcd_x++;
               if(lcd_x>16)
               {
                  lcd_x=1;
                  lcd_y++;
                  if(lcd_y>2)
                     lcd_y=1;
               }
            #endif
            #ifdef   glcd
               if(i==0)
                   glcd_rect(glcd_x,glcd_y,glcd_x+length*6,glcd_y+6,1,inverse);
               sprintf(display_char,"%c",character);
               glcd_text57(glcd_x,glcd_y,string,1,!inverse);
               glcd_x+=6;
            #endif
            #ifdef   tft_lcd
               if(i==0)
                   glcd_rectagle(glcd_x,glcd_y,glcd_x+length*9,glcd_y+16,white,inverse);
               sprintf(display_char,"%c",character);
               glcd_text57(glcd_x,glcd_y,string,1,!inverse);
               glcd_x+=6;
            #endif
           i++;
         }
      }
      do
      {
         character=keyboard_getc();
      }while(character!=ENTER&&character!=ESC&&character!=BACKSPACE);
      if(character==ENTER)
      {
         for(j=0;j<i;j++)
               *(array++)=string[j];
         return(1);
      }
      else if(character==BACKSPACE)
         goto backbackspace;
      else
         return(0);
}
//--------------------------------------------------------------------
#endif





